--- origsrc/hdf5-1.10.1-pre1/configure.ac	2017-03-24 22:45:47.000000000 +0100
+++ src/hdf5-1.10.1-pre1/configure.ac	2017-04-08 22:09:00.165067200 +0200
@@ -843,19 +843,6 @@ AC_SUBST([RUNPARALLEL])
 AC_SUBST([TESTPARALLEL])
 
 ## ----------------------------------------------------------------------
-## Disable shared libraries on CYGWIN. (LK - 04/16/15)
-## A number of tests run by "make check" fail on CYGWIN, so for HDF5 v1.8.15
-## we will change the default for shared libraries to disabled.
-
-
-case "`uname`" in
-  CYGWIN*)
-    enable_shared="no"
-    CHECK_WARN="Shared libraries are not currently supported on CYGWIN."
-    ;;
-esac
-
-## ----------------------------------------------------------------------
 ## Check if they would like the Java native interface (JNI) compiled
 ##
 
--- origsrc/hdf5-1.10.1-pre1/test/Makefile.am	2017-03-24 22:39:15.000000000 +0100
+++ src/hdf5-1.10.1-pre1/test/Makefile.am	2017-04-08 16:59:22.575489900 +0200
@@ -102,18 +102,18 @@ endif
 
 if HAVE_SHARED_CONDITIONAL
   # The libh5test library provides common support code for the tests.
-  noinst_LTLIBRARIES=libh5test.la
 
   # The libdynlib1, libdynlib2, libdynlib3, and libdynlib4 library for testing plugin module plugin.c.
   # Build it as shared library if configure is enabled for shared library.
-  lib_LTLIBRARIES=libdynlib1.la libdynlib2.la libdynlib3.la libdynlib4.la
+  noinst_LTLIBRARIES=libh5test.la libdynlib1.la libdynlib2.la libdynlib3.la libdynlib4.la
   libdynlib1_la_SOURCES=dynlib1.c
   libdynlib2_la_SOURCES=dynlib2.c
   libdynlib3_la_SOURCES=dynlib3.c
   libdynlib4_la_SOURCES=dynlib4.c
-
-install-exec-hook:
-	$(RM) $(DESTDIR)$(libdir)/*dynlib*
+  libdynlib1_la_LIBADD=$(LIBHDF5)
+  libdynlib2_la_LIBADD=$(LIBHDF5)
+  libdynlib3_la_LIBADD=$(LIBHDF5)
+  libdynlib4_la_LIBADD=$(LIBHDF5)
 
 else
   # The libh5test library provides common support code for the tests.
--- origsrc/hdf5-1.10.1-pre1/tools/test/h5diff/Makefile.am	2017-03-24 22:39:15.000000000 +0100
+++ src/hdf5-1.10.1-pre1/tools/test/h5diff/Makefile.am	2017-04-08 17:05:32.896671000 +0200
@@ -52,11 +52,9 @@ LDADD=$(LIBH5TOOLS) $(LIBHDF5)
 
 if HAVE_SHARED_CONDITIONAL
   # Build it as shared library if configure is enabled for shared library.
-  lib_LTLIBRARIES=libdynlibdiff.la
+  noinst_LTLIBRARIES=libdynlibdiff.la
   libdynlibdiff_la_SOURCES=dynlib_diff.c
-
-install-exec-hook:
-	$(RM) $(DESTDIR)$(libdir)/*dynlib*
+  libdynlibdiff_la_LIBADD=$(LIBHDF5)
 endif
 
 # Temporary files.  *.h5 are generated by h5diff.  They should
--- origsrc/hdf5-1.10.1-pre1/tools/test/h5dump/Makefile.am	2017-03-24 22:39:15.000000000 +0100
+++ src/hdf5-1.10.1-pre1/tools/test/h5dump/Makefile.am	2017-04-08 17:06:21.386444500 +0200
@@ -41,11 +41,9 @@ LDADD=$(LIBH5TOOLS) $(LIBHDF5)
 
 if HAVE_SHARED_CONDITIONAL
   # Build it as shared library if configure is enabled for shared library.
-  lib_LTLIBRARIES=libdynlibdump.la
+  noinst_LTLIBRARIES=libdynlibdump.la
   libdynlibdump_la_SOURCES=dynlib_dump.c
-
-install-exec-hook:
-	$(RM) $(DESTDIR)$(libdir)/*dynlib*
+  libdynlibdump_la_LIBADD=$(LIBHDF5)
 endif
 
 # Temporary files.  *.h5 are generated by h5dumpgentest.  They should
--- origsrc/hdf5-1.10.1-pre1/tools/test/h5ls/Makefile.am	2017-03-24 22:39:15.000000000 +0100
+++ src/hdf5-1.10.1-pre1/tools/test/h5ls/Makefile.am	2017-04-08 17:07:30.130376400 +0200
@@ -38,11 +38,9 @@ LDADD=$(LIBH5TOOLS) $(LIBHDF5)
 
 if HAVE_SHARED_CONDITIONAL
   # Build it as shared library if configure is enabled for shared library.
-  lib_LTLIBRARIES=libdynlibls.la
+  noinst_LTLIBRARIES=libdynlibls.la
   libdynlibls_la_SOURCES=dynlib_ls.c
-
-install-exec-hook:
-	$(RM) $(DESTDIR)$(libdir)/*dynlib*
+  libdynlibls_la_LIBADD=$(LIBHDF5)
 endif
 
 DISTCLEANFILES=h5ls_plugin.sh
--- origsrc/hdf5-1.10.1-pre1/tools/test/h5repack/Makefile.am	2017-03-24 22:39:15.000000000 +0100
+++ src/hdf5-1.10.1-pre1/tools/test/h5repack/Makefile.am	2017-04-08 17:03:23.007241800 +0200
@@ -47,12 +47,11 @@ h5repacktst_SOURCES=h5repacktst.c
 
 if HAVE_SHARED_CONDITIONAL
   # Build it as shared library if configure is enabled for shared library.
-  lib_LTLIBRARIES=libdynlibadd.la libdynlibvers.la
+  noinst_LTLIBRARIES=libdynlibadd.la libdynlibvers.la
   libdynlibadd_la_SOURCES=dynlib_rpk.c
   libdynlibvers_la_SOURCES=dynlib_vrpk.c
-
-install-exec-hook:
-	$(RM) $(DESTDIR)$(libdir)/*dynlib*
+  libdynlibadd_la_LIBADD=$(LIBHDF5)
+  libdynlibvers_la_LIBADD=$(LIBHDF5)
 endif
 
 # Temporary files.  *.h5 are generated by h5repack.  They should